#include "bbcreaMaracasVisuCutModule2.h"
#include "bbcreaMaracasVisuPackage.h"
#include "creaSystem.h"

namespace bbcreaMaracasVisu
{

	BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,CutModule2)
	BBTK_BLACK_BOX_IMPLEMENTATION(CutModule2,bbtk::WxBlackBox);
	void CutModule2::Process()
	{
		vtkImageData* img = bbGetInputIn();
		vtkRenderWindowInteractor* interactor = bbGetInputInteractor();
		vtkRenderer* render = bbGetInputRenderer();

		if(img != NULL && interactor != NULL && render != NULL && _mainpanel!=NULL){

			if(_currentimage!=img){
				_currentimage=img;
				_mainpanel->setImageData(img);
			}
			
			_mainpanel->setInteractor(interactor);
			_mainpanel->setRenderer(render);
			bbSetOutputOut(_mainpanel->GetResultImage());
		}   
	}
	void CutModule2::CreateWidget(wxWindow* parent)
	{

		std::string path = crea::System::GetDllAppPath("bbcreaMaracasVisu.dll");
		_mainpanel = CutModelMainPanel::getInstance(parent, path);
		_mainpanel->SetType(1);
		
	   bbSetOutputWidget( _mainpanel); 
	   Process(); 
	  
	}
	void CutModule2::bbUserSetDefaultValues()
	{	
		_mainpanel = NULL;
		_currentimage=NULL;
	}
	void CutModule2::bbUserInitializeProcessing()
	{
		bbSetInputIn(0);
		bbSetInputInteractor(0);
		bbSetInputRenderer(0);	
	}
	void CutModule2::bbUserFinalizeProcessing()
	{

	}
}
// EO namespace bbcreaMaracasVisu


