#include "bbcreaMaracasVisuRenderingViewer.h"
#include "bbcreaMaracasVisuPackage.h"

#include "wxMaracasRendererView.h"
#include "wxMaracasRenderTabbedPanel.h"

namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,RenderingViewer)
BBTK_BLACK_BOX_IMPLEMENTATION(RenderingViewer,bbtk::WxBlackBox);
void RenderingViewer::Process()
{
	wxMaracasRendererView* view = (wxMaracasRendererView*)bbGetOutputWidget();
	vtkImageData* _img1 = bbGetInputIn1();
	vtkImageData* _img2 = bbGetInputIn2();
	vtkImageData* _img3 = bbGetInputIn3();
	vtkImageData* _img4 = bbGetInputIn4(); 

	vtkRenderer* renderer = bbGetInputRenderer();

	if(view != NULL)
	{
		view->setVtkBaseView( (wxVtk3DBaseView*) bbGetInputwxVtkBaseView() );

		if(renderer != NULL && _currentrenderer != renderer)
		{
			view->setRenderer(renderer);
			_currentrenderer = renderer;
			//_currentrendererSA = rendererSA;
			//_currentrendererSB = rendererSB;
			//_currentrendererSC = rendererSC;
		}
		if(_currentrenderer!=NULL /*&& _currentrendererSA!=NULL && _currentrendererSB!=NULL && _currentrendererSC!=NULL*/)
		{
			if(_img1 !=NULL)
			{
				view->addVolumes(_img1, "","INPUT 1");
			}
			if(_img2 !=NULL)
			{
				view->addVolumes(_img2, "", "INPUT 2");
			}
			if(_img3 !=NULL)
			{
				view->addVolumes(_img3, "", "INPUT 3");
			}
			if(_img4 !=NULL)
			{
				view->addVolumes(_img4, "", "INPUT 4");
			}
		}		
	} 

	bbSetOutputImageFiles( view->getFiles() );

}
void RenderingViewer::CreateWidget(wxWindow* parent)
{
	wxMaracasRendererView* surrend = wxMaracasRendererView::getInstance(parent);
	bbSetOutputWidget(surrend);
}
void RenderingViewer::bbUserSetDefaultValues()
{
	bbSetInputIn1(NULL);
	bbSetInputIn2(NULL);
	bbSetInputIn3(NULL);
	bbSetInputIn4(NULL);
	bbSetInputRenderer(NULL);
	bbSetOutputWidget(NULL);
	bbSetOutputOut1(NULL);
	bbSetOutputOut2(NULL);
	bbSetOutputOut3(NULL);
	bbSetOutputOut4(NULL);
}
void RenderingViewer::bbUserInitializeProcessing()
{

}
void RenderingViewer::bbUserFinalizeProcessing()
{

}
}
// EO namespace bbcreaMaracasVisu


