#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuRenderingViewer_h_INCLUDED__
#define __bbcreaMaracasVisuRenderingViewer_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkWxBlackBox.h"

#include "vtkImageData.h"
#include "vtkProp3D.h"
#include "vtkRenderer.h"
#include "wxVtkBaseView.h"

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT RenderingViewer
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(RenderingViewer,bbtk::WxBlackBox);
  //BBTK_DECLARE_INPUT(Title,std::string); 
  BBTK_DECLARE_INPUT(Renderer,vtkRenderer*);
  BBTK_DECLARE_INPUT(wxVtkBaseView,wxVtkBaseView*);
  BBTK_DECLARE_INPUT(In1,vtkImageData*);
  BBTK_DECLARE_INPUT(In2,vtkImageData*);
  BBTK_DECLARE_INPUT(In3,vtkImageData*);
  BBTK_DECLARE_INPUT(In4,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out1,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out2,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out3,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out4,vtkImageData*);
  BBTK_DECLARE_OUTPUT(ImageFiles, std::vector<std::string>);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

  private:
	vtkRenderer* _currentrenderer;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(RenderingViewer,bbtk::WxBlackBox);
BBTK_NAME("RenderingViewer");
BBTK_AUTHOR("Carolina Perez");
BBTK_DESCRIPTION("Complex box which gathers VolumeRendering and SurfaceRendering funtionalities");
BBTK_CATEGORY("actor");
//BBTK_INPUT(RenderingViewer,Title,"Title prepended to the text",std::string,"");
BBTK_INPUT(RenderingViewer,Renderer,"Renderer to show volume rendering image" ,vtkRenderer*, "");
BBTK_INPUT(RenderingViewer,wxVtkBaseView,"wxVtkBaseView",wxVtkBaseView*,"");
//BBTK_INPUT(RenderingViewer,RendererSA,"Renderer to show surface rendering image" ,vtkRenderer*, "");
//BBTK_INPUT(RenderingViewer,RendererSB,"Renderer to show surface rendering image" ,vtkRenderer*, "");
//BBTK_INPUT(RenderingViewer,RendererSC,"Renderer to show surface rendering image" ,vtkRenderer*, "");
BBTK_INPUT(RenderingViewer,In1,"Input image to the Rendering",vtkImageData*,"");
BBTK_INPUT(RenderingViewer,In2,"Input image to the Rendering",vtkImageData*,"");
BBTK_INPUT(RenderingViewer,In3,"Input image to the Rendering",vtkImageData*,"");
BBTK_INPUT(RenderingViewer,In4,"Input image to the Rendering",vtkImageData*,"");
BBTK_OUTPUT(RenderingViewer,Out1,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(RenderingViewer,Out2,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(RenderingViewer,Out3,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(RenderingViewer,Out4,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(RenderingViewer,ImageFiles,"File Name", std::vector<std::string>,"");
BBTK_END_DESCRIBE_BLACK_BOX(RenderingViewer);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuRenderingViewer_h_INCLUDED__
#endif // _USE_WXWIDGETS_

