#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuColorBar_h_INCLUDED__
#define __bbcreaMaracasVisuColorBar_h_INCLUDED__
#include "bbtkWxBlackBox.h"

#include "bbcreaMaracasVisuPackage.h"
#include "pColorBar.h"


namespace bbcreaMaracasVisu
{

class /*BBTK_EXPORT*/ ColorBar
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ColorBar,bbtk::WxBlackBox);
    BBTK_DECLARE_INPUT(Orientation, int );
	BBTK_DECLARE_INPUT(InW, int );
	BBTK_DECLARE_INPUT(InH, int );
	BBTK_DECLARE_INPUT(InMax, int );
	BBTK_DECLARE_INPUT(InMin, int );
	BBTK_DECLARE_INPUT(Reds, std::vector<int> );
	BBTK_DECLARE_INPUT(Greens, std::vector<int> );
	BBTK_DECLARE_INPUT(Blues, std::vector<int> );
	BBTK_DECLARE_INPUT(Values, std::vector<int> );
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

  private:
	pColorBar *mwxwidget;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ColorBar,bbtk::WxBlackBox);
BBTK_NAME("ColorBar");
BBTK_AUTHOR("eduardo.davila [at] creatis.insa-lyon.fr");
BBTK_DESCRIPTION("Degrade Color Bar Window");
//BBTK_CATEGORY("__CategoryBlackBox__");
  BBTK_INPUT(ColorBar,Orientation,"Orientation ", int,"");
  BBTK_INPUT(ColorBar,InW,"Width ", int,"");
  BBTK_INPUT(ColorBar,InH,"Height ", int,"");
  BBTK_INPUT(ColorBar,InMax,"Max value ", int,"" );
  BBTK_INPUT(ColorBar,InMin, "Min value ",int,"" );
  BBTK_INPUT(ColorBar,Reds, "Reds ",std::vector<int>,"");
  BBTK_INPUT(ColorBar,Greens, "Greens ",std::vector<int>,"");
  BBTK_INPUT(ColorBar,Blues, "Blues ",std::vector<int>,"");
  BBTK_INPUT(ColorBar,Values, "Values ",std::vector<int>,"");
BBTK_END_DESCRIBE_BLACK_BOX(ColorBar);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuColorBar_h_INCLUDED__
#endif // _USE_WXWIDGETS_

