#include "bbmaracasvisuContourStatistics.h"
#include "bbcreaMaracasVisuPackage.h"
#include <math.h>
namespace bbcreaMaracasVisu
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ContourStatistics)
BBTK_BLACK_BOX_IMPLEMENTATION(ContourStatistics,bbtk::AtomicBlackBox);

//------------------------------------------------------------
void ContourStatistics::Process()
{

	  double max=0,min=0;
	  double average=0,standardeviation=0;
	  double acum=0;
	  double ng;
	  int size=0;
	  if (bbGetInputLstValue()!=NULL)
	  {
		size=bbGetInputLstValue()->size();
		if (size>0){
	       max=(*bbGetInputLstValue())[0];
		   min=(*bbGetInputLstValue())[0];
     // Average
			int i;
			for ( i=0; i<size; i++ )
			{
				ng=(*bbGetInputLstValue())[i];
				acum = acum + ng;
				if (max<ng) max=ng;		// Max
				if (min>ng) min=ng;     // Min
			}
			average = acum / size;

	  // Standar Deviation
			acum=0;
			double tmp;
  			for ( i=0; i<size; i++ )
			{
                tmp = (*bbGetInputLstValue())[i] - average;
				acum = acum + tmp*tmp;
			}
			standardeviation = sqrt(acum/size);

		}
	  }

	  // OUTPUT
      bbSetOutputMax( max );
      bbSetOutputnPoints( size );
      bbSetOutputMin( min );
      bbSetOutputAverage( average );
      bbSetOutputStandarDeviation( standardeviation );
}

//------------------------------------------------------------
void ContourStatistics::bbUserSetDefaultValues()
{
      bbSetInputLstValue(NULL);
}

	
	//-----------------------------------------------------------------	
	void ContourStatistics::bbUserInitializeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	void ContourStatistics::bbUserFinalizeProcessing()
	{
	}
	
	//-----------------------------------------------------------------	
	

}
// EO namespace bbcreaMaracasVisu


