#ifndef __bbcreaMaracasVisuImageActor_h_INCLUDED__
#define __bbcreaMaracasVisuImageActor_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"


#include <vtkImageData.h>
#include <vtkImageActor.h>
#include <vtkRenderer.h>
#include <vtkTransform.h>
#include <vtkLinearTransform.h>
#include <vtkImageShiftScale.h>


namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT ImageActor
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ImageActor,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Transform,vtkLinearTransform*);
  BBTK_DECLARE_INPUT(Renderer,vtkRenderer*);
  BBTK_DECLARE_OUTPUT(Out,vtkProp3D*);
  BBTK_PROCESS(Process);
  void Process();
  bool firsttime;
  vtkImageActor *imageactor;
  vtkImageShiftScale *imageshiftscale;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ImageActor,bbtk::AtomicBlackBox);
BBTK_NAME("ImageActor");
BBTK_AUTHOR("InfoDev CREATIS-LRMN");
BBTK_DESCRIPTION("put image in a 3D univers");
BBTK_CATEGORY("");
BBTK_INPUT(ImageActor,In,"Image input",vtkImageData*,"");
BBTK_INPUT(ImageActor,Transform,"Transform",vtkLinearTransform*,"");
BBTK_INPUT(ImageActor,Renderer,"Renderer",vtkRenderer*,"");
BBTK_OUTPUT(ImageActor,Out,"Output vtk actor",vtkProp3D*,"");
BBTK_END_DESCRIBE_BLACK_BOX(ImageActor);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuImageActor_h_INCLUDED__

