#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuTransferFunctionView_h_INCLUDED__
#define __bbcreaMaracasVisuTransferFunctionView_h_INCLUDED__
#include "bbtkWxBlackBox.h"

#include "vtkImageData.h"
//#include "HistogramWidget.h"
#include "HistogramDialogComboBox.h"

#include "vtkPiecewiseFunction.h"
#include "vtkColorTransferFunction.h"
#include <wx/wx.h>

namespace bbcreaMaracasVisu
{

  

class /*BBTK_EXPORT*/ TransferFunctionView
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(TransferFunctionView,bbtk::WxBlackBox);
	BBTK_DECLARE_INPUT(In, vtkImageData*);
	BBTK_DECLARE_OUTPUT(OpacityFunction, vtkPiecewiseFunction*);
	BBTK_DECLARE_OUTPUT(ColorFunction, vtkColorTransferFunction*);

	BBTK_DECLARE_OUTPUT(WindowLevel, double);
	BBTK_DECLARE_OUTPUT(ColorLevel, double);
	/*BBTK_DECLARE_OUTPUT(GreyLevel, std::vector<double> );
	BBTK_DECLARE_OUTPUT(Value, std::vector<double> );
	BBTK_DECLARE_OUTPUT(GreyLevelColors, std::vector<double>);
	BBTK_DECLARE_OUTPUT(Red, std::vector<double>);
	BBTK_DECLARE_OUTPUT(Green, std::vector<double>);
	BBTK_DECLARE_OUTPUT(Blue, std::vector<double>);*/

  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow* parent);  

  void onColorChange();

  void onSliderChange();

  private:
	//HistogramWidget *mwxwidget;
	  HistogramDialogComboBox *mwxwidget;
	vtkImageData* _currentimg;
	
	vtkPiecewiseFunction* _tfun;
	vtkColorTransferFunction* _ctfun;
};

class HandlerTransferFunctionView : public wxEvtHandler
{
	public:
		HandlerTransferFunctionView(TransferFunctionView* box);
		~HandlerTransferFunctionView();    
		
		 void onColorChange(wxCommandEvent& event);

		 void onSliderChange(wxCommandEvent& event);
		
	private:
		TransferFunctionView			*_box;	
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(TransferFunctionView,bbtk::WxBlackBox);
BBTK_NAME("TransferFunctionView");
BBTK_AUTHOR("eduardo.davila [at] creatis.insa-lyon.fr");
BBTK_DESCRIPTION("Transfer Function Window");
//BBTK_CATEGORY("__CategoryBlackBox__");
  BBTK_INPUT(TransferFunctionView,In,"Input image",vtkImageData*,"");
	BBTK_OUTPUT(TransferFunctionView,OpacityFunction,"Transfer function for the opacity", vtkPiecewiseFunction*,"");
	BBTK_OUTPUT(TransferFunctionView,ColorFunction,"Transfer function for the color", vtkColorTransferFunction*,"");  
	BBTK_OUTPUT(TransferFunctionView,WindowLevel,"WidowLevel for the current window", double,"");  
	BBTK_OUTPUT(TransferFunctionView,ColorLevel,"ColorLevel for the current window", double,"");  
  /*BBTK_OUTPUT(TransferFunctionView,GreyLevel,"Greylevel related to the transparency",std::vector<double>,"");
  BBTK_OUTPUT(TransferFunctionView,Value,"Value of the transparency in the transfer function",std::vector<double>,"");
  BBTK_OUTPUT(TransferFunctionView,GreyLevelColors,"Grey level of the color in the transfer function",std::vector<double>,"");
  BBTK_OUTPUT(TransferFunctionView,Red,"Red value according to the GreyLevelColors",std::vector<double>,"");
  BBTK_OUTPUT(TransferFunctionView,Green,"Green value according to the GreyLevelColors",std::vector<double>,"");
  BBTK_OUTPUT(TransferFunctionView,Blue,"Blue value according to the GreyLevelColors",std::vector<double>,"");*/
BBTK_END_DESCRIBE_BLACK_BOX(TransferFunctionView);
}


// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuTransferFunctionView_h_INCLUDED__
#endif // _USE_WXWIDGETS_

