#ifndef __contoursIntersection_h_INCLUDED__
#define __contoursIntersection_h_INCLUDED__

#include "vectorFunctions.h"

class contoursIntersection
{
  public:
		contoursIntersection  ( );
		~contoursIntersection ( );
        double Slope                ( double x0, double y0,
                                      double x1, double y1 );
        double Normal               ( double x0, double y0,
                                      double *m, double xi );
        void Intersection           ( double x01, double y01,
                                      double x02, double y02,
                                      double mn, double m2,
                                      double *x, double *y );
        void SetContour1            ( std::vector<double>*InX1,
                                      std::vector<double>*InY1,
                                      std::vector<double>*InZ1 );
        void SetContour2            ( std::vector<double>*InX2,
                                      std::vector<double>*InY2,
                                      std::vector<double>*InZ2 );
        //All the intersections between the two set contour
        void InterBetweenContours   ( std::vector<double>*OutX,
                                      std::vector<double>*OutY,
                                      std::vector<double>*OutZ );
        //All the possible intersections between the contours
        void PossibleIntersections  ( std::vector<double>*OutX,
                                      std::vector<double>*OutY,
                                      std::vector<double>*OutZ );
        //Logical intersections between the two set contours
        void IntersectionPoints     ( std::vector<double>*OutX,
                                      std::vector<double>*OutY,
                                      std::vector<double>*OutZ );
        //Set the parameter data for stimate the error between the contours
        void SetErrorParameter      ( double val );
        //The error between the contours
        int GetErrorBetweenContours ( double error );
   private:
         std::vector<double> _InX1;
         std::vector<double> _InY1;
         std::vector<double> _InZ1;
          std::vector<double> _InX2;
         std::vector<double> _InY2;
         std::vector<double> _InZ2;
};
#endif
 
 
