/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasFrame.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__MARACAS__FRAME__HXX__
#define __WX__MARACAS__FRAME__HXX__

#include <wx/wx.h>
#include <wx/frame.h>
#include "marTypes.h"
#include "wxMaracas3DBrowser.h"
#include "wxMaracasQuantification.h"
#include <kernel/marSimpleDicom.h>

class marInterface;

/**
 * \brief Principal Frame of the application 
 * MARACAS: MAgnetic Resonance Angiography Computer ASsisted analysis
 *
 */

class MAR_INTERFACEWX_EXPORT wxMaracasFrame: public wxFrame
{
public:

    wxMaracasFrame( wxFrame *parent, wxWindowID id = -1,
            marInterface* mar = NULL, marSimpleDicom *simpleDicom=NULL, char *dictionaryFileName=NULL,
            const wxString& title = wxT("MARACAS: MAgnetic Resonance Angiography Computer ASsisted analysis"),
            const wxPoint& pos = wxDefaultPosition,
            const wxSize& size = wxDefaultSize,
            long style = wxDEFAULT_FRAME_STYLE);
	
	void OnDeleteAxis(wxCommandEvent &event);
	void OnNewAxis(wxCommandEvent &event);
	
    void RecreateToolbar( );

	void OnAboutCreatis( wxCommandEvent& event );
    void OnQuit( wxCloseEvent& event );
// PS ->     void OnLoadPatientData( wxCommandEvent& event );
    void OnParameters( wxCommandEvent& event );
// PS ->     void OnLoadImageData( wxCommandEvent& event );
    void OnStartExperiment( wxCommandEvent& event );
// PS ->     void OnHelp (wxCommandEvent& event );
    void OnQuant (wxCommandEvent& event );

	void OnRegenerateAll( wxCommandEvent& event );
	void OnRegenerateSplineAxe(	wxCommandEvent& event );
	void OnCleanContours( wxCommandEvent& event );
	void OnRegenerateSignal( wxCommandEvent& event );



	wxMaracas3DBrowser*			Getwxmaracas3dbrowser()			{ return _wxmaracas3dbrowser;		}
	wxMaracasQuantification*	Getwxmaracasquantification()	{ return _wxmaracasquantification;	}

private:
    wxPanel					*_actual_panel;
    wxGauge					*_progressGauge;
    marInterface			*_mar;
	marSimpleDicom			*_marSimpleDicom;

	wxMaracas3DBrowser		*_wxmaracas3dbrowser;
	wxMaracasQuantification *_wxmaracasquantification;

    DECLARE_EVENT_TABLE( );

	void DeletePanels();
};

static const long TOOLBAR_STYLE = wxNO_BORDER | wxTB_FLAT | wxTB_DOCKABLE | wxTB_HORIZONTAL;

enum
{
    //! Toolbar & menu buttons
    ID_TOOLBAR = 200,
    ID_TOOLBAR_DATA_BROWSER,
    ID_TOOLBAR_PARAMETERS,
    ID_TOOLBAR_IMAGE_BROWSER,
    ID_TOOLBAR_3D_BROWSER,
    ID_TOOLBAR_PLANS,
    ID_TOOLBAR_QUANT,
    ID_TOOLBAR_ROTATE,
    ID_TOOLBAR_BRIGHT,
    ID_TOOLBAR_PAN,
    ID_TOOLBAR_ZOOM,
    ID_TOOLBAR_CLEAR,
    ID_TOOLBAR_INTENSITY,
    ID_TOOLBAR_HELP,
};

#endif // __WX__MARACAS__FRAME__HXX__
