/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasQuantificationCT.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "wxMaracasFrame.h"
#include "wxMaracasQuantificationCT.h"


wxMaracasQuantificationCT::wxMaracasQuantificationCT( wxWindow* parent,
                                                  marInterfaceCT* mar, wxWindowID id )
: wxPanel( parent, id, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL)
{

  _mar = mar;

  // Create the main frame window
  _3DQuantif = new wxQuantificationWidgetCT( this, -1 );
  wxBoxSizer* szTop = new wxBoxSizer( wxVERTICAL );


  
  szTop->Add( _3DQuantif, 1  , wxEXPAND |  wxALL , 0 );
  this->SetAutoLayout( true );
  this->SetSizer( szTop );
  szTop->Fit( this );
  szTop->SetSizeHints( this );
}
//----------------------------------------------------------------------------
wxMaracasQuantificationCT::~wxMaracasQuantificationCT( ){
  // Nothing
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::LoadData( ){
  _3DQuantif->ShowMARACASData( _mar );
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::Do_Quant( ){
  // _3DQuantif->Do_Quant( );
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::SetSlider_Isovalue_Opacity(int isovalue,int opacity){
	_3DQuantif->SetSlider_Isovalue_Opacity(isovalue,opacity);
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::RegenerateAll(bool all){
	if (_3DQuantif!=NULL){
		_3DQuantif->Clean3D(true);
		if (all==true){
			_mar->RegenerateAxis();
		} else {
			_mar->RecalculateAxis();
		}
		_3DQuantif->AddAxisActors();	
		_3DQuantif->ResetAxis();	
		_3DQuantif->RefreshAxis();	
	}
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::CleanContours(){
	if (_3DQuantif!=NULL){
		_3DQuantif->Clean3D(false);
		_mar->ClearContours();
		_3DQuantif->ResetAxis();	
		_3DQuantif->RefreshAxis();	
	}
} 	
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::RegenerateSignal(){
	if (_3DQuantif!=NULL){
		_3DQuantif->Clean3D(false);
		_mar->RegenerateSignal();
		_3DQuantif->ResetAxis();	
		_3DQuantif->RefreshAxis();	
	}
}
//----------------------------------------------------------------------------
int wxMaracasQuantificationCT::GetActualSlice()
{
	return this->_3DQuantif->GetActualSlice();
}
//----------------------------------------------------------------------------
void wxMaracasQuantificationCT::SetActualSlice(int slice)
{
	this->_3DQuantif->SetActualSlice(slice);
}
//----------------------------------------------------------------------------


// EOF - wxMaracasQuantification.cxx




