

/**
 *  \file 
 *  \brief Class ThresholdImageViewPanel . 
 */

/**
 * \class ThresholdImageViewPanel
 * \brief 
 */
 
#ifndef __ThresholdImageViewPanel_h__
#define __ThresholdImageViewPanel_h__


#include <wx/wx.h>
#include "mBarRange.h"
#include "ThresholdImageView.h"

	
	class ThresholdImageViewPanel
		: public wxPanel
		{
		public:
			ThresholdImageViewPanel(wxWindow * parent, int min, int max, int type);		
			~ThresholdImageViewPanel();
			void onThresholdStop();
			void SetThresholdImageView(ThresholdImageView* thresholdImageView);
			bool IsVisible();
			
		private:
			
			bool				_thresholdGo;
			ThresholdImageView	*_thresholdImageView;
			mBarRange			*_mBarThreshold;
			wxSlider			*_opacity;
			wxCheckBox			*_interpolationCheckBox;	
			wxCheckBox			*_cb_ShowHide;
			
			void onThresholdChange(wxCommandEvent& event);			
			void onThresholdShow(wxCommandEvent& event);
			void onThresholdInterpolation(wxCommandEvent& event);
			void onChangeOpacity(wxScrollEvent& event);
			DECLARE_EVENT_TABLE()
		};
	
	
	

#endif

