/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxManualSegmentation_MPRWidget.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:57 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__MANUAL_SEGMENTATION__MPRWIDGET__HXX__
#define __WX__MANUAL_SEGMENTATION__MPRWIDGET__HXX__

#include "wxMPRWidget.h"
#include "../manualContour.h"
#include <wx/notebook.h>





//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------


class wxManualSegmentation_MPRWidget : public wxPanel
{

public:
    wxManualSegmentation_MPRWidget(wxWindow* parent,marImageData *marimageData,double voxelSize);
	~wxManualSegmentation_MPRWidget( );

	void ConfigureVTK();

	void RefreshView();
	void OnRefreshView(wxCommandEvent & event);


	vtkMPRBaseData		*GetVtkMPRBaseData();
	vtkPlane2DView		*GetVtkPlane2DView();
	vtkRenderer			*GetRenderer();



private:
	double								_voxelSize;
	marImageData						*_marimageData; 
	wxMPRWidget2						*_MPRWidget2;

	//
	wxVtk3DBaseView						*_wxvtk3Dbaseview_Clipping3D_C;
	wxVtkMPR3DView						*_wxvtkmpr3Dview_C;
	wxVtkClipping3DView					*_wxvtkclipping3Dview_C;

	wxPanel		*Create3DViewContour( wxWindow *parent, vtkMPRBaseData *vtkmprbasedata);
	void		ConfigureContour();

	//MaracasTools* maracasTools;

	DECLARE_EVENT_TABLE( );



};




#endif // __WX__MANUAL__TREE__SEGMENTATION__WIDGET__HXX__ 

// EOF - wxManualSegmentation_MPRWidget.h
