#include "manualContourModelCircle.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

manualContourModelCircle::manualContourModelCircle()
: manualContourModel()
{
}

manualContourModelCircle::~manualContourModelCircle()
{
}


// ----------------------------------------------------------------------------
manualContourModelCircle * manualContourModelCircle :: Clone()  // virtual
{
	manualContourModelCircle * clone = new manualContourModelCircle();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------

void manualContourModelCircle::CopyAttributesTo( manualContourModelCircle * cloneObject)
{
	// Fathers object
	manualContourModel::CopyAttributesTo(cloneObject);
}

//----------------------------------------------------------------
int manualContourModelCircle::GetTypeModel() //virtual
{
	return 3;
}

//----------------------------------------------------------------
void manualContourModelCircle::GetSpline_i_Point(int i, double *x, double *y, double *z) // virtal
{
	double angle = _deltaAngle*i;
	*x = _radio*cos(angle) + _centerX;
	*y = _radio*sin(angle) + _centerY;
	*z = _centerZ;
}

//
// ---------------------------------------------------------------------------
void manualContourModelCircle::UpdateSpline() // virtal
{
	manualPoint	*mpA,*mpB;
	double difX,difY;
    int np	= GetSizeLstPoints( );
	int nps = GetNumberOfPointsSpline();
	_deltaAngle=(3.14159265*2)/(nps-1);

	if (np==2){
		mpA			= GetManualPoint(0);
		mpB			= GetManualPoint(1);
		difX		= mpA->GetX() - mpB->GetX();
		difY		= mpA->GetY() - mpB->GetY();
		_radio		= sqrt( difX*difX + difY*difY );
		_centerX	= mpA->GetX();
		_centerY	= mpA->GetY();
		_centerZ	= mpA->GetZ();
	} else {
		_radio		= -1;
		_centerX	= -1;
		_centerY	= -1;
		_centerZ	= -1;
	}
}
