

#ifndef __HISTOGRAMW1__
#define __HISTOGRAMW1__


// ----------------------------------------------------------------------------
// wx headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include "marTypes.h"
#include "pPlotterWindow.h"
#include "pFunctionPoint.h"
#include  "vtkImageData.h"
#include "pHistogram.h"
#include "pPlotterScaleY.h"
#include "pPlotterScaleX.h"

//#define MAX 500
#define NUM_POINTS 100
#define WINDOW_SIZE 10

class creaMaracasVisu_EXPORT Histogram:public wxPanel
{
public:
	//---------------------
	// Constructor
	//----------------------

	//HistogramWidget( wxWindow *parent, wxWindowID id, const wxPoint &pos, const wxSize &size, int flag );
	
 
//EED Borrame 07Mai2009
//	Histogram( wxWindow *parent, wxWindowID id, const wxPoint &pos, const wxSize &size, int flag,vtkImageData* imageData);
	Histogram( wxWindow *parent, wxWindowID id, const wxPoint &pos, const wxSize &size, int flag);
	
	~Histogram();

	/*
	Draw the histogram in the plotter
	*/
	void drawHistogram();
	/*
		if the user resize the window	
	*/
	void OnSize( wxSizeEvent &WXUNUSED(event) );
	//---------------------------------------
	// Get Information from the widget
	//---------------------------------------
	
	/*
		get a point of the Histogram
		given the grey value
	*/
	int getHistogramPoint(int gValue);
	int getHistogramSize();
	void Configure(vtkImageData* imageData);
	
private:
	
	 pHistogram*		histogram;
	 pPlotterWindow*	plotter;
	 int				histogramSize;
	 int				 idHistogram;
	 
	 
	 DECLARE_CLASS(Histogram);
	 //----------------------------------------------------------------------------
	// wxWidget macro use declaration for handdling events
	//----------------------------------------------------------------------------
	DECLARE_EVENT_TABLE()
	
};
#endif


