#include "MaximumsDialog.h"

IMPLEMENT_CLASS(MaximumsDialog, wxDialog)

MaximumsDialog::MaximumsDialog(wxWindow *parent,wxString title)
:wxDialog(parent,-1,title,wxDefaultPosition,wxDefaultSize, wxDEFAULT_DIALOG_STYLE,_T("dialogBox"))
{
	/*
	 where the user can put the values of the maxX and maxY of the axes of the plotter
	*/
	m_maxX = new wxTextCtrl( this, -1, wxT(""));
    m_maxY = new wxTextCtrl( this, -1, wxT(""));

	/*
	* just labels
	*/
	maxX=new wxStaticText(this,-1,_T("Max X:"));
	maxY=new wxStaticText(this,-1,_T("Max Y:"));
	
	/*
	Buttons
	*/
	okBtn = new wxButton(this,wxID_OK ,_T("OK"));
	cancelBtn = new wxButton(this,wxID_CANCEL,_T("Cancel"));

	//BOXES
	//Upper Box
	wxBoxSizer * upper_box = new wxBoxSizer( wxHORIZONTAL );
	//Including components for plotter control
	upper_box->Add( maxX, wxSizerFlags().Border(wxALL,6));
	upper_box->Add( m_maxX, wxSizerFlags().Border(wxALL,6));
	upper_box->Add( maxY, wxSizerFlags().Border(wxALL,6));
	upper_box->Add( m_maxY, wxSizerFlags().Border(wxALL,6));
	

	//bottom Sizer
	wxBoxSizer *bottomBox = new wxBoxSizer( wxHORIZONTAL );
	bottomBox->Add( okBtn, wxSizerFlags().Center());
	bottomBox->AddSpacer(40);
	bottomBox->Add( cancelBtn,wxSizerFlags().Center() );

	// Adding the components to the sizer
	wxFlexGridSizer *sizer = new wxFlexGridSizer(1);
	sizer->Add( upper_box,0,wxALIGN_BOTTOM);
	//sizer->AddGrowableRow (1,1);
	sizer->Add( bottomBox,0,wxALIGN_CENTER);
    
	SetAutoLayout( TRUE );
    SetSizer( sizer );
	SetBestSize(wxSize(325,100));
}
//-----------------------------------------------------------------
float MaximumsDialog::getXValue()
{
	wxString mx=m_maxX->GetValue();
	if(mx.IsNumber())
	{
			return (float)atoi( (const char*)(mx.mb_str()) );
	}
	else
		return -1;
}
//----------------------------------------------------------------
float MaximumsDialog::getYValue()
{
	wxString my=m_maxY->GetValue();
	if(my.IsNumber())
	{
			return atof( (const char*) (my.mb_str()) );
	}
	else
		return -1;
}
//----------------------------------------------------------------



