/*=========================================================================

  Program:   Visualization Toolkit
  Module:    $RCSfile: vtkClosePolyData.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:34 $
  Version:   $Revision: 1.2 $

  Copyright (c) 1993-2002 Ken Martin, Will Schroeder, Bill Lorensen 
  All rights reserved.
  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.

     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
// .NAME vtkClosePolyData - close a polygonal dataset
// .SECTION Description
// 
// vtkClosePolyData is a filter that blabla

// .SECTION Thanks
// Thanks to Goodwin Lawlor for http://public.kitware.com/pipermail/vtkusers/2003-March/016420.html
// and Mathieu Malaterre for this class.

// .SECTION See Also
// vtkAppendFilter

#ifndef __vtkClosePolyData_h
#define __vtkClosePolyData_h

#include "vtkPolyDataToPolyDataFilter.h"

class vtkClosePolyData : public vtkPolyDataToPolyDataFilter
{
public:
  static vtkClosePolyData *New();

  vtkTypeRevisionMacro(vtkClosePolyData,vtkPolyDataToPolyDataFilter);
  void PrintSelf(ostream& os, vtkIndent indent);

protected:
  vtkClosePolyData();
  ~vtkClosePolyData();

  // Usual data generation method
  void Execute();

private:
  vtkClosePolyData(const vtkClosePolyData&);  // Not implemented.
  void operator=(const vtkClosePolyData&);  // Not implemented.
};

#endif


