#ifndef wxMaracasMultipleVolumeRendererPanel_H_
#define wxMaracasMultipleVolumeRendererPanel_H_

#include <wx/wx.h>
#include "HistogramDialogComboBox.h"

class wxMaracasMultipleVolumeRendererPanel : public wxPanel{
	
public:
	wxMaracasMultipleVolumeRendererPanel(wxWindow* parent, int propid, vtkImageData* img, bool _isComplexBox);
	~wxMaracasMultipleVolumeRendererPanel();
	void createControls(vtkImageData* img);	
	void onCheckBoxChange(wxCommandEvent& event);
	void onColorChange(wxCommandEvent& event);
	void onOK(wxCommandEvent& event);
	void onCancel(wxCommandEvent& event);
	void onUpdate(wxCommandEvent& event);
	void onViewImage(wxCommandEvent& event);
	void onRadioBoxSelectFunction(wxCommandEvent& event);

	void updateVolume();
	int getPropId();
	HistogramDialogComboBox* getMwxwidget();

private:
	wxCheckBox* checkbox;
	wxRadioBox* _radiobox;
	wxBitmapButton* _viewimage;
	
	int _propid;

	bool first;

	HistogramDialogComboBox* mwxwidget;
	//wxFrame* _frame;

	//-- added for complex box --//
	bool isComplexBox;
};

#endif /*wxMaracasMultipleVolumeRendererPanel_H_*/
