#ifndef wxMaracasRenderImageTransformation_H_
#define wxMaracasRenderImageTransformation_H_

#include <vtkTransform.h>

#include "wxMaracasMultipleVolumeRendererManager.h"
#include "wxMaracasSurfaceRenderingManager.h"
#include "creaMaracasVisu_EXPORT.h"

class creaMaracasVisu_EXPORT wxMaracasRenderImageTransformation
{
public:

	wxMaracasRenderImageTransformation(wxMaracasMultipleVolumeRendererManager* vol, wxMaracasSurfaceRenderingManager* surface1, 
		wxMaracasSurfaceRenderingManager* surface2, wxMaracasSurfaceRenderingManager* surface3, int id);
	~wxMaracasRenderImageTransformation();

	void Translate(int tx, int ty, int tz, int rx, int ry, int rz, int sx, int sy, int sz);
	void Refresh()throw(char*);

private:
	wxMaracasMultipleVolumeRendererManager* vol;
	wxMaracasSurfaceRenderingManager* surface1;
	wxMaracasSurfaceRenderingManager* surface2;
	wxMaracasSurfaceRenderingManager* surface3;
	
	vtkTransform* transformV;
	vtkTransform* transformS1;
	vtkTransform* transformS2;
	vtkTransform* transformS3;

	int propID;
};

#endif
