/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasRendererView.h,v $
  Language:  C++

=========================================================================*/

#ifndef __wxMaracasRendererViewPanelH__
#define __wxMaracasRendererViewPanelH__

#include <vector>
#include <wx/wx.h>
#include "wx/aui/aui.h"
#include <iostream>
#include "marTypes.h"
#include "vtkProp3D.h"
#include "wxVtkBaseView.h"

#include "wxMaracasRendererView.h"
#include "wxMaracasRenderTabbedPanel.h"
#include "wxMaracasMultipleVolumeRendererManager.h"
#include "wxMaracasSurfaceRenderingManager.h"

class  creaMaracasVisu_EXPORT  wxMaracasRendererView : public wxPanel
{

public:
	wxMaracasRendererView( wxWindow* parent, std::string path);
        ~wxMaracasRendererView( );

	static wxMaracasRendererView* getInstance(wxWindow* parent,std::string path="");
	static wxMaracasRendererView* getInstance();

	std::string getPath();
	wxMaracasRenderTabbedPanel* getTabbedPanel(int id) throw(char*);

	void setRenderer(vtkRenderer*  renderer); /* throw(char*), */   // JPR
	void setVtkBaseView(wxVtk3DBaseView* base);
	void onLoadImageFile();
	void addVolumes(vtkImageData* img, std::string pathfile, std::string filename);
	void addPanels(wxMaracasRenderTabbedPanel* wxtabs, vtkImageData* img, std::string pathfile, std::string filename);

	void deleteVolume(int volid);
	std::vector<std::string> getFiles();

private:
	static wxMaracasRendererView* instance;

	std::vector<wxMaracasRenderTabbedPanel*> tabsVector;
	std::vector<std::string> files;

	wxAuiManager* wxauimanager;
	wxToolBar * _toolb;

	vtkRenderer*  _renderer;
	wxVtk3DBaseView* baseView;
	std::string _path;

	int _idCount;
};

class ToolBarEventHandlerRenderer : public wxEvtHandler
{
	public:
		ToolBarEventHandlerRenderer();
		~ToolBarEventHandlerRenderer();

		void onLoadImageFile(wxCommandEvent& event);

	private:

		DECLARE_EVENT_TABLE()
	};

class ToolBarRenderer : public wxToolBar{

public:
	ToolBarRenderer(wxWindow * parent,std::string iconsdir);
	~ToolBarRenderer(void);

private:

	ToolBarEventHandlerRenderer* _evthand;
};

#endif
