/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasSuperposition.cxx,v $
  Language:  C++
  Date:      $Date: 2009/06/08 12:35:29 $
  Version:   $Revision: 1.5 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "wxMaracasSuperposition.h"
#include "creaWx.h"
#include "vtkMetaImageReader.h"
#include "wx/artprov.h"



wxMaracasSuperposition* wxMaracasSuperposition::instance=NULL;

wxMaracasSuperposition::wxMaracasSuperposition( wxWindow* parent, std::vector<vtkImageData*> imgs): wxPanel(parent, -1, wxDefaultPosition, wxDefaultSize)
{	
	m_mgr.SetManagedWindow(this);
	
	_superposition1 = NULL;
	_superposition2 = NULL;
	_superposition3 = NULL;	
	
	_images = imgs;
	
	// set up default notebook style
	m_notebook_style =wxAUI_NB_TAB_SPLIT | wxAUI_NB_TAB_EXTERNAL_MOVE | wxNO_BORDER;
	m_notebook_theme = 0;
	_notebook = this->createNotebook();
	
	createPanels();
	configurePanels();
}

wxMaracasSuperposition::~wxMaracasSuperposition()
{
	_notebook->Destroy();
	instance = NULL;
	m_mgr.UnInit();
}

wxMaracasSuperposition* wxMaracasSuperposition :: getInstance ( wxWindow* parent, std::vector<vtkImageData*> imgs)
{
		if(instance == NULL)
		{
			instance = new wxMaracasSuperposition(parent, imgs);
		}
		return instance;
}
	
wxMaracasSuperposition* wxMaracasSuperposition :: getInstance()
{
	return instance;
}

//------------------------------------------------------------------------------------------------------------
// Creational and initialization methods using WxAui
//------------------------------------------------------------------------------------------------------------

wxAuiNotebook * wxMaracasSuperposition :: createNotebook()
{
	wxSize client_size = GetClientSize();
	wxAuiNotebook* noteBook = new wxAuiNotebook(this, -1, wxPoint(client_size.x, client_size.y), wxSize(430,200), m_notebook_style);
	wxBitmap page_bmp = wxArtProvider::GetBitmap(wxART_NORMAL_FILE, wxART_OTHER, wxSize(16,16));

	return noteBook;
}

void wxMaracasSuperposition :: configurePanels()
{
	if( _superposition1!=NULL )
	{
		_notebook->AddPage( _superposition1, wxT("       Superoposition 1       ") );		
		m_mgr.Update();
	}

	if( _superposition2!=NULL )
	{
		_notebook->AddPage( _superposition2, wxT("       Superoposition 2       ") );
		m_mgr.Update();
	}
	
	if( _superposition3!=NULL )
	{
		_notebook->AddPage( _superposition3, wxT("       Superoposition 3       ") );
		m_mgr.Update();
	}
	

	m_mgr.AddPane(_notebook, wxAuiPaneInfo().Name(wxT("notebook_content")).CenterPane().PaneBorder(false));
	m_mgr.Update();
 
	SetMinSize(wxSize(300,300));
	m_mgr.Update();
}

void wxMaracasSuperposition :: createPanels()
{
	if( _superposition1==NULL )
	{
		_superposition1 = new wxMaracasSuperpositionPanel ( _images, 1, _notebook );
	}
	
	else if( _superposition1!=NULL )
	{
		
	}

	if( _superposition2==NULL )
	{
		_superposition2 = new wxMaracasSuperpositionPanel ( _images, 2, _notebook );
	}
	
	else if( _superposition2!=NULL )
	{
		
	}
	
	if( _superposition3==NULL )
	{
		_superposition3 = new wxMaracasSuperpositionPanel ( _images, 3, _notebook );
	}
	
	else if( _superposition3!=NULL )
	{
		
	}	
}


void wxMaracasSuperposition :: changeImages(std::vector<vtkImageData*> imgs)
{
	_images = imgs;
	
	createPanels();
	configurePanels();
}

std::vector<vtkImageData*> wxMaracasSuperposition :: getImages( )
{
		return _images;
}	
