/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasSuperposition.h,v $
  Language:  C++
  Date:      $Date: 2009/06/05 16:44:25 $
  Version:   $Revision: 1.4 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __wxMaracasSuperpositionH__
#define __wxMaracasSuperpositionH__

#include <vector>
#include <wx/wx.h>
#include "wx/aui/aui.h"
#include "wxMaracasSuperpositionPanel.h"
#include "vtkMetaImageReader.h"
#include "vtkImageData.h"




class creaMaracasVisu_EXPORT wxMaracasSuperposition : public wxPanel
{	

public:
	
	wxMaracasSuperposition(wxWindow* parent, std::vector<vtkImageData*> imgs);

	~wxMaracasSuperposition();

	static wxMaracasSuperposition* getInstance(wxWindow* parent, std::vector<vtkImageData*> imgs);
	
	static wxMaracasSuperposition* getInstance();
	
	wxAuiNotebook * createNotebook();

	void createPanels();

	void configurePanels();

	void changeImages(std::vector<vtkImageData*> imgs);

	std::vector<vtkImageData*> getImages( );

	
private:

	static wxMaracasSuperposition * instance;

	wxAuiManager m_mgr;
	
	wxAuiNotebook * _notebook;

	std::vector<vtkImageData*> _images;
	
	wxMaracasSuperpositionPanel * _superposition1;
	
	wxMaracasSuperpositionPanel * _superposition2;
	
	wxMaracasSuperpositionPanel * _superposition3;

    long m_notebook_style;
	
    long m_notebook_theme;
};

#endif

