/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marExperimentCT.cpp,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:07 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/


#include "marExperimentCT.h"


// ----------------------------------------------------------------------------
marExperimentCT::marExperimentCT( marParameters* p ) : marExperiment( p )
                              
{
  
}

// ----------------------------------------------------------------------------
marContour* marExperimentCT::getContour( int point, int contour ) {
	return ((marAxisCT *)getAxis())->getContour(point,getDynData()->getVolume(),contour);
}

// ----------------------------------------------------------------------------
vtkPoints*	marExperimentCT::get3Dcontour( int point, int contour ) {
	return ((marAxisCT *)getAxis())->get3Dcontour(point,getDynData()->getVolume(),contour);
}

// ----------------------------------------------------------------------------
vtkPolyData* marExperimentCT::get2Dcontour( int point, int contour ) {
	return ((marAxisCT *)getAxis())->get2Dcontour(point,getDynData()->getVolume(),contour);
}

// ----------------------------------------------------------------------------
vtkPoints* marExperimentCT::get2DDiameterMin( int point, int contour ) {
	return ((marAxisCT *)getAxis())->get2DDiameterMin(point,getDynData()->getVolume(),contour);
}

// ----------------------------------------------------------------------------
vtkPoints* marExperimentCT::get2DDiameterMax( int point, int contour ) {
	return ((marAxisCT *)getAxis())->get2DDiameterMax(point,getDynData()->getVolume(),contour);;
}

// ----------------------------------------------------------------------------
int marExperimentCT::getNumberOfContours(int point) {
	return ((marAxisCT *)getAxis())->getNumberOfContours(point,getDynData()->getVolume( )) ;
}

// ----------------------------------------------------------------------------
void marExperimentCT::prepareQuantification( ) {

	if(getAxis())
	{
		((marAxisCT *)getAxis())->eraseContours();
		((marAxisCT *)getAxis())->createEmptyContours();
		marExperiment::prepareQuantification();
	}
	
}

// ----------------------------------------------------------------------------
void marExperimentCT::RegenerateAxis() {

	if (getAxis()!=NULL){
		((marAxisCT *)getAxis())->eraseContours();
		((marAxisCT *)getAxis())->createEmptyContours();
	//	marExperiment::RegenerateAxis();
	}

	
}

// ----------------------------------------------------------------------------
void marExperimentCT::RecalculateAxis() {

	if (getAxis()!=NULL){
		((marAxisCT *)getAxis())->eraseContours();
		((marAxisCT *)getAxis())->createEmptyContours();
		marExperiment::RecalculateAxis();
	}
	
}

// ----------------------------------------------------------------------------
void marExperimentCT::updateLumenPercentage(int percentage)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	((marAxisCT *)getAxis())->getParameters()->setLumenPercentage(percentage);
	((marAxisCT *)getAxis())->updateLumenPercentage(point,getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::updateCalcPercentage(int percentage) 
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	((marAxisCT *)getAxis())->getParameters()->setCalcPercentage(percentage);
	((marAxisCT *)getAxis())->updateCalcPercentage(point,getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::updateDiscontinuityThreshold(int percentage)
{
	((marAxisCT *)getAxis())->getParameters()->setContourThresh(percentage);
	((marAxisCT *)getAxis())->eraseContours();
	((marAxisCT *)getAxis())->createEmptyContours();
	((marAxisCT *)getAxis())->setCalibration(false);

}



// ----------------------------------------------------------------------------
int	marExperimentCT::getContourType(int point, int index) {
	return ((marAxisCT *)getAxis())->getContourType(point, index, getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::histogram(int point) {
	
	((marAxisCT *)getAxis())->histogram(point, getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::setCalibration(bool calib)
{
	((marAxisCT *)getAxis())->setCalibration(calib);
}

// ----------------------------------------------------------------------------
bool marExperimentCT::getCalibration()
{
	return ((marAxisCT *)getAxis())->getCalibration();
}

// ----------------------------------------------------------------------------
void marExperimentCT::ClearContoursPartial(int start)
{
	((marAxisCT *)getAxis())->eraseContoursPartial(start);
}

// ----------------------------------------------------------------------------
void marExperimentCT::setStartIndex(int start)
{
	((marAxisCT *)getAxis())->setStartIndex(start);
}

// ----------------------------------------------------------------------------
int	marExperimentCT::getPointSize()
{
	return ((marAxisCT *)getAxis())->getPointSize();
}

// ----------------------------------------------------------------------------
marPoint* marExperimentCT::getPoint(int i)
{
	return ((marAxisCT *)getAxis())->getPoint(i);
}

// ----------------------------------------------------------------------------
void marExperimentCT::markUpLumen(int point)
{
	((marAxisCT *)getAxis())->markUpLumen(point, getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::generateFile()
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	((marAxisCT *)getAxis())->generateFile(point, getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
void marExperimentCT::replaceContour2D(int size,double *vx,double *vy, int type)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	((marAxisCT *)getAxis())->replaceContour2D(point,size,vx,vy,type);
}

// ----------------------------------------------------------------------------
void marExperimentCT::cleanContours(int type)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	((marAxisCT *)getAxis())->cleanContours(type,point);
}

// ----------------------------------------------------------------------------
marIsocontour* marExperimentCT::loadMarIsocontour(int size, double *vx, double *vy)
{
	return ((marAxisCT *)getAxis())->loadMarIsocontour(size,vx,vy);
}

// ----------------------------------------------------------------------------
double marExperimentCT::performXOR(int type, std::vector<marIsocontour*> manual)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();

	return ((marAxisCT *)getAxis())->performXOR(type,point,manual, getDynData()->getVolume());
}

// ----------------------------------------------------------------------------
double marExperimentCT::performAND(int type, std::vector<marIsocontour*> manual)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	 
	return ((marAxisCT *)getAxis())->performAND(type,point,manual, getDynData()->getVolume());
	

}

// ----------------------------------------------------------------------------
double marExperimentCT::performUnion(int type, std::vector<marIsocontour*> manual)
{
	int point = ((marAxisCT *)getAxis())->getActualQuant();
	 
	return ((marAxisCT *)getAxis())->performUnion(type,point,manual, getDynData()->getVolume());
}
