/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marExperimentCT.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:07 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__EXPERIMENTCT__HXX__
#define __MAR__KERNEL__EXPERIMENTCT__HXX__

#include <vector>
#include "volume.hxx"
#include "marExperiment.h"
#include "marDynData.h"
#include "GestionBifurcations.h"
#include "marAxisCT.h"
#include "marPoint.h"

class MAR_KERNEL_EXPORT marExperimentCT : public marExperiment
{

public:
  
  marExperimentCT( marParameters* p = NULL );
  
  marContour*		getContour( int point, int contour );
  vtkPoints*		get3Dcontour( int point, int contour );
  vtkPolyData*		get2Dcontour( int point, int contour );
  vtkPoints*		get2DDiameterMin( int point, int contour );
  vtkPoints*		get2DDiameterMax( int point, int contour );
  int				getNumberOfContours(int point);
  void				prepareQuantification( );
  void				RegenerateAxis();
  void				RecalculateAxis();
  void				updateLumenPercentage(int percentage);
  void				updateCalcPercentage(int percentage);
  void				updateDiscontinuityThreshold(int percentage);
  int				getContourType(int point, int index);
  void				histogram(int point);
  void				setCalibration(bool calib);
  bool				getCalibration();
  void				ClearContoursPartial(int start);
  void				setStartIndex(int start);
  int				getPointSize();
  marPoint*			getPoint(int i);
  void				markUpLumen(int point);
  void				generateFile();
  void				replaceContour2D(int size,double *vx,double *vy, int type);
  void				cleanContours(int type);
  marIsocontour*	loadMarIsocontour(int size, double *vx, double *vy);
  double			performXOR(int type, std::vector<marIsocontour*> manual);
  double			performAND(int type, std::vector<marIsocontour*> manual);
  double			performUnion(int type, std::vector<marIsocontour*> manual);

};

#endif // __MAR__KERNEL__EXPERIMENTCT__HXX__
