// marMatrix.h: interface for the marMatrix class.
//
//////////////////////////////////////////////////////////////////////

#include <iostream>
#include <stddef.h>
#include "marVector.h"

class marMatrix  
{
public:
/*==Constructeurs========================================*/
	marMatrix(const marMatrix &m);
	marMatrix(double * data,size_t size1=3,size_t size2=3);
	marMatrix(size_t size1,size_t size2);
/*==Constructeurs========================================*/
	virtual ~marMatrix();

/*==oprateurss========================================*/
    friend std::ostream& operator<<(std::ostream& os, const marMatrix& m);
 
	marMatrix& operator=( const marMatrix& o );
    marMatrix& operator=( double o );
    marMatrix& operator=( double* o );

    operator double*( ) const;

    double& operator()( size_t i, size_t j );
    const double& operator()( size_t i, size_t j ) const;

    marMatrix operator+( const marMatrix& o );
    marMatrix operator+( double o );
    marMatrix operator+( double* o );

	marMatrix operator-( const marMatrix& o );
    marMatrix operator-( double o );
    marMatrix operator-( double* o );

	marMatrix operator*( const marMatrix& o );
    marVector operator*( const marVector& o );
    marMatrix operator*( double o );

    bool operator==( const marMatrix& o ) const;
    bool operator!=( const marMatrix& o ) const;

/*==Mthodes========================================*/
	size_t columns() const;
	size_t rows() const;

/*==Attributs========================================*/
private:
	bool shallowCopy; // true if _data is a shallow copy of original data (pointer copy)
	size_t _size1;
	size_t _size2;
	double* _data;
};

