/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marObject.cpp,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:43 $
  Version:   $Revision: 1.2 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "marObject.h"

// -------------------------------------------------------------------------
marObject::marObject( marParameters* p )
{
    _parameters = p;
    _parametersCopied = false;
}

// -------------------------------------------------------------------------
marObject::~marObject( )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
}

// -------------------------------------------------------------------------
void marObject::setParameters( marParameters* p )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
    _parameters = p;
    _parametersCopied = false;
}

// -------------------------------------------------------------------------
void marObject::copyParameters( marParameters* p )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
    _parameters = new marParameters( );
    *_parameters = *p;
    _parametersCopied = true;
}

// -------------------------------------------------------------------------
bool marObject::save( std::string& nw )
{
    std::ofstream os( nw.c_str( ) );

    if( os ) {

	save( os );
	os.close( );
	return( true );

    } // fi

    return( false );
}

// -------------------------------------------------------------------------
bool marObject::load( std::string& nr )
{
    std::ifstream is( nr.c_str( ) );

    if( is ) {

	load( is );
	is.close( );
	return( true );

    } // fi

    return( false );
}

// eof - object.cxx
